/******************************************************************************
*
*  lame.cmd
*
*  Encode MP3 with lame and take ID3 tag information from EA's.
*
*  Update:  25.09.2002
*  (C)      Marcel Mller 2002
*
******************************************************************************/

IF RxFuncAdd("SysLoadFuncs", "RexxUtil", "SysLoadFuncs") = 0 THEN
   CALL SysLoadFuncs
IF RxFuncAdd("MMLoadFuncs", "RxMMutl", "MMLoadFuncs") = 0 THEN
   CALL MMLoadFuncs

fname = ''
outdir = ''
params = STRIP(ARG(1))
DO WHILE params \= ''
   IF LEFT(params,1) = '"' THEN DO
      PARSE VAR params '"'param'"'params
      params = STRIP(params, 'L')
      END
    ELSE
      PARSE VAR params param params
   /* param is the next parameter to process ... */
   IF (LEFT(param, 1) = '/') | (LEFT(param, 1) = '-') THEN DO
      /* parsing options ... */
      opt = TRANSLATE(SUBSTR(param, 2, 1))
      SELECT
       WHEN opt = 'O' THEN
         outdir = SUBSTR(param, 3)
       OTHERWISE
         CALL Error 44, "illegal option '"param"'"
         END
      ITERATE
      END
   /* any other arg ... */
   fname = param
   opt = params
   LEAVE /* only 1 file */
   END

IF fname = '' THEN DO
   SAY "usage: lame [options] file [lame options]"
   SAY "options:"
   SAY " /Odir    Output directory. The original file name(s) are preserved, except"
   SAY "          for the file extension. By default the files are created in the same"
   SAY "          directory as the original files. Use /O. to force the current"
   SAY "          working directory instead."
   EXIT 48
   END

fname = TRANSLATE(fname, '\', '/')
oname = fname
IF LASTPOS('.', oname) = LENGTH(oname)-3 THEN
   oname = DELSTR(oname, LENGTH(oname)-3)
IF outdir \= '' THEN
   oname = STRIP(outdir, 'T', '\')'\'FILESPEC('N',oname)
oname = oname'.mp3'

/* title infos? */
trk = GetTitleInfo(fname, "CDT-Track")
album = GetTitleInfo(fname, "CDT-Album")
artist = GetTitleInfo(fname, "CDT-Artist", trk)
title = GetTitleInfo(fname, "CDT-Title", trk)
comment = GetTitleInfo(fname, "CDT-Comment", trk)
year = GetTitleInfo(fname, "CDT-Year", trk)

IF artist = '' THEN DO
   tmp = album
   PARSE VAR tmp artist' / 'album
   IF album = '' THEN DO
      /* 2nd try */
      PARSE VAR tmp artist' - 'album
      IF album = '' THEN DO
         /* give up */
         album = tmp
         artist = ''
         END
      END
   artist = STRIP(artist)
   album = STRIP(album)
   IF ABBREV(TRANSLATE(artist), 'VARIOUS') THEN
      artist = ''
   IF title = '' THEN DO
      tmp = title
      PARSE VAR tmp tartist' / 'title
      IF title = '' THEN DO
         IF artist = '' THEN DO
            /* 2nd try */
            PARSE VAR tmp artist' - 'title
            IF title = '' THEN DO
               title = tmp
               artist = ''
               END
            END
          ELSE
            title = tmp
         END
       ELSE
         artist = tartist
      artist = STRIP(artist)
      title = STRIP(title)
      END
   END

CALL AddOpt "--tt", title
CALL AddOpt "--ta", artist
CALL AddOpt "--tl", album
CALL AddOpt "--ty", year
CALL AddOpt "--tn", trk
CALL AddOpt "--tc", comment

SAY fname oname opt

CALL SysSetPriority 1, 1
'@LAME.EXE 'opt PCTesc(fname) PCTesc(oname)
/*'@PEC LAME.EXE 'opt PCTesc(fname) PCTesc(oname)*/
CALL SysSetPriority 2, 0

CALL SysPutEA oname, '.TYPE', 'DFFF00000100FDFF0300'x || 'MP3'

EXIT 0

GetTitleInfo: PROCEDURE
   rc = SysGetEA(ARG(1), ARG(2), 'EA')
   IF rc = 0 & ea \= '' THEN
      RETURN SUBSTR(ea, 11)
   IF ARG(3,'e') THEN
      rc = SysGetEA(ARG(1), ARG(2)'-'ARG(3), 'EA')
   IF rc = 0 THEN
      RETURN SUBSTR(ea, 11)
   RETURN ''

AddOpt: PROCEDURE EXPOSE opt
   IF ARG(2) \= '' THEN
      opt = opt ARG(1)' "'ARG(2)'"'
   RETURN

PCTesc: PROCEDURE
   tmp = ARG(1)
   p = POS('%', tmp)
   DO WHILE p \= 0
      tmp = INSERT('%', tmp, p)
      p = POS('%', tmp, p+2)
      END
   RETURN '"'tmp'"'

